#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>
#include <assert.h>
#include <cilk/cilk.h>
typedef unsigned long long uint64_t;
//#define n 4096
#define n 1024
double A[n][n];
double B[n][n];
double C[n][n];
double D[n][n];
float tdiff (struct timeval *start, struct timeval *end)
{
return (end->tv_sec - start->tv_sec) + 1e-6* (end->tv_usec - start->tv_usec);
}

int main(int argc, const char *argv[]) 
{
for (int i=0; i<n; ++i)
{ 
  for (int j=0; j<n; ++j)
{ 
   A[i][j] = (double)rand() / (double)RAND_MAX;
B[i][j] = (double)rand() / (double)RAND_MAX;
C[i][j] = 0; 
D[i][j] = 0;
}
}

struct timeval start, end;
gettimeofday( &start, NULL);
cilk_for (int i=0; i<n; ++i)
{
cilk_for ( int j=0; j<n; ++j)
{ for ( int k=0; k<n; ++k) 
{
C[i][j] += A[i][k] * B[k][j]; 
}
}
}
gettimeofday(&end, NULL);
printf("%0.6f\n", tdiff(&start, &end)); 
float numf = (double)rand() / (double)RAND_MAX;
int num = (int) numf % (n);
printf("numf+%f, num=%d\n", numf,num);


for (int i=0; i<n; ++i)
{
for ( int j=0; j<n; ++j)
{ for ( int k=0; k<n; ++k) 
{
D[i][j] += A[i][k] * B[k][j]; 
}
}
}

for (int i=0; i<n; ++i)
{
  for (int j=0; j<n; ++j)
{
   if(C[i][j] != D[i][j]) { printf("MATMUL INVALID\n");}
}
}


printf("printing a random element from C: (to avoid dead code elimination)%lf, num:%d\n", C[num][num], num);
return 0;
}
